<?php
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

function sanction(){

    $inCore = cmsCore::getInstance();
    $inUser = cmsUser::getInstance();
    $inPage = cmsPage::getInstance();
    $inDB   = cmsDatabase::getInstance();

    $inCore->loadModel('sanction');
    $model = new cms_model_sanction();

    if(!$model->config['component_enabled'] || !$inUser->id) { cmsCore::error404(); }
    if (!in_array($inUser->group_id, $model->config['see_sanctions']) && !$inUser->is_admin) { cmsCore::error404(); }
    
    $do         = $inCore->request('do', 'str', 'view');
    $page       = $inCore->request('page', 'int', 1);
    $id         = $inCore->request('id', 'int', 0);
    $perpage = 30;

//============================================================================//

    if ($do=='delete'){
        
        if (!$id) { cmsCore::error404(); }
        
        $model->delSanction($id);
        $inCore->redirectBack();
    }

//============================================================================//

    if ($do=='view'){
        
        $inPage->setTitle('Санкции и штрафы');
        $inPage->addPathway('Список выданных санкций');

        $total = $model->getCountSanctions();
        $inDB->limitPage($page, $perpage);

        $sanctions = $model->getSanctions();

	if(!$sanctions && $page > 1){ cmsCore::error404(); }
        
        if ($sanctions){
            $result = $inDB->query("SELECT * FROM cms_user_groups_access ORDER BY `access_type` ASC");
            if($inDB->num_rows($result)){
                while($type = $inDB->fetch_assoc($result)){
                    $access_types[$type['access_name']] = $type['access_type'];
                    $access_names[$type['access_type']] = $type['access_name'];
                }
                foreach($sanctions as $key => $sanction){
                    $sanctions[$key]['access'] = str_replace($access_types, $access_names, $sanction['access']);
                    $sanctions[$key]['access'] = explode(',', $sanctions[$key]['access']);
                }
            }
        }

        $smarty = $inCore->initSmarty('components', 'com_sanction_view.tpl');
        $smarty->assign('sanctions', $sanctions);
	$smarty->assign('pagebar', cmsPage::getPagebar($total, $page, $perpage, '/sanction/page-%page%'));
        $smarty->display('com_sanction_view.tpl');
    }
    
//============================================================================//
    
    if ($do=='add'){

        if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest' || !$id) { echo '1';cmsCore::halt(); }
        $usr = $inDB->get_field('cms_users', '`id`='.$id, 'login'); 
        if (!$usr){ cmsCore::jsonOutput(array('error' => true, 'text'  => 'Пользователь не найден!')); }
        if($model->config['rezhim']===2){
            $between = $inDB->get_field('cms_sanction_notice', 'user_id = '.$id.' AND `date` > DATE_SUB(NOW(), INTERVAL '.$model->config['rz2']['between_notify'].' MINUTE)', 'id'); 
            if ($between && !$inUser->is_admin){ cmsCore::jsonOutput(array('error' => true, 'text'  => 'Пользователь уже получил недавно предупреждение!')); }
            $between_for_one = $inDB->get_field('cms_sanction_notice', 'user_id = '.$id.' AND `who_gave_id`='.$inUser->id.' AND `date` > DATE_SUB(NOW(), INTERVAL '.$model->config['rz2']['between_notify_for_one'].' MINUTE)', 'id'); 
            if ($between_for_one && !$inUser->is_admin){ cmsCore::jsonOutput(array('error' => true, 'text'  => 'Вы не можете так часто давать предупреждения пользователю!')); }
            $user_lvl = $inDB->rows_count('cms_sanction_notice', 'user_id = '.$id);
            $user_lvl = $user_lvl ? $user_lvl : 0;
            $all_lvls = count($model->config['rz2']['chain']);
        }
        if (!cmsCore::inRequest('goadd')){
            
        if ($model->config['rezhim']===2)echo "<p>У пользователя $user_lvl-й  уровень предупреждений из $all_lvls возможных.</p>";
        echo '<form action="/sanction/add" method="post" name="addform" id="addform">
                <input type="hidden" name="goadd" value="1" />
                <input type="hidden" name="csrf_token" value="'.cmsUser::getCsrfToken().'" />
                <input type="hidden" name="id" value="'.$id.'" />
                    <table border="0" cellspacing="0" cellpadding="6" width="100%">';
        if($model->config['rezhim']===1 || in_array($inUser->group_id, $model->config['see_rz1_always'])){
            $result = $inDB->query("SELECT * FROM cms_user_groups_access ORDER BY `access_type` ASC");
            if($inDB->num_rows($result)){
                while($type = $inDB->fetch_assoc($result)){
                    $access_types[$type['access_name']] = $type['access_type'];
                    $access_names[$type['access_type']] = $type['access_name'];
                }
                echo '<tr><td><strong>Выдать ограничение на:</strong></td>';
                echo '<td><ul style="list-style:none;padding:0;">';
                foreach($model->config['rz1']['access'][$inUser->group_id] as $key => $value){
                    if(!$value)continue;
                    echo '<li style="margin:0;"><input name="access[]" type="checkbox" value="'.$key.'"> - '.$access_names[$key].'</li>';
                }
                echo '</ul></td></tr>';
                echo '<tr><td><strong>Время (минут):</strong></td>
                    <td><input name="minutes" type="text" value="15"/></td></tr>';
                if($model->config['rezhim']===2)echo '<tr><td><strong>Не поднимать уровень предупреждений:</strong></td>
                    <td><input name="not_notice" type="checkbox" value="1" checked="checked"></td></tr>';
            }
        }
        echo '              <tr>
                                    <td width="170"><strong>Причина наказания:</strong></td>
                                    <td><input name="reason" type="text" class="text-input" style="width:350px" value="Нарушение правил"/></td>
                            </tr>
                    </table>
            </form>
            <script type="text/javascript" src="/includes/jquery/jquery.form.js"></script>
            <div class="sess_messages" style="display:none">
              <div class="message_info" id="error_mess"></div>
            </div>';
        
        cmsCore::jsonOutput(array('error' => false, 'html' => ob_get_clean()));
        
    }else{
        if(!cmsCore::validateForm()) { cmsCore::halt(); }
        
        $sanction['reason']     = cmsCore::request('reason', 'str', '');
        $sanction['minutes']    = cmsCore::request('minutes', 'int', 0);
        $sanction['access']     = cmsCore::request('access', 'array', '');
        $sanction['not_notice'] = cmsCore::request('not_notice', 'int', 0);
        if (mb_strlen($sanction['reason'])<5) { cmsCore::jsonOutput(array('error' => true, 'text' => 'Указанная причина слишком короткая.')); }
        if ($model->config['rezhim']===1 && !$sanction['access']) { cmsCore::jsonOutput(array('error' => true, 'text' => 'Не выбраны ограничения.')); }
        if ($sanction['minutes'] > $model->config['rz1']['max_mins'] && !$inUser->is_admin) { cmsCore::jsonOutput(array('error' => true, 'text' => 'Максимально допустимое время ограничения - '.$model->config['rz1']['max_mins'].' минут')); }

		if (!$sanction['not_notice']){
			if($model->addNotice($id, $sanction, $inUser->id)){
                            cmsCore::addSessionMessage('Предупреждение пользователю выдано', 'success');
                            if($model->config['send_notify'])cmsUser::sendMessage(USER_UPDATER, $id, 'Вам было выдано предупреждение. <a href="'.$inUser->getProfileURL($usr).'#upr_p_sanction">Подробнее</a>');
                        }
		}

		if ($sanction['access']){
                    foreach($sanction['access'] as $key => $value){
                        if($model->config['rz1']['access'][$inUser->group_id][$value])continue;
                        else cmsCore::jsonOutput(array('error' => true, 'text' => 'У вас нет прав на выдачу такого ограничения'));
                    }
                    
                    if($model->addSanction($id, $sanction, $inUser->id)){
                        cmsCore::addSessionMessage('Ограничение пользователю выдано успешно', 'success');
                        if($model->config['send_notify'])cmsUser::sendMessage(USER_UPDATER, $id, 'Вам было выдано ограничение. <a href="'.$inUser->getProfileURL($usr).'#upr_p_sanction">Подробнее</a>');
                    }
		}

        cmsUser::clearCsrfToken();

	cmsCore::jsonOutput(array('error' => false, 'redirect'  => $inUser->getProfileURL($usr)));
    }

    }
//======================================================================================================================//

} //function
?>