<?php
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

class cms_model_sanction{

		private static  $instance;
        private $inDB;
		public  $config = array();

/* ========================================================================== */
/* ========================================================================== */

    public function __construct(){
                $this->inDB   = cmsDatabase::getInstance();
		$this->config = cmsCore::getInstance()->loadComponentConfig('sanction');
    }
	
    public static function getInstance() {
        if (self::$instance === null) {
            self::$instance = new self();
        }
        return self::$instance;
    }

/* ========================================================================== */
/* ========================================================================== */

    public static function getDefaultConfig() {
        $inDB   = cmsDatabase::getInstance();
        $cfg = array(
            'rezhim'=>1,
            'send_notify'=>1,
            'see_rz1_always'=>array('2'),
            'see_sanctions'=>array('2'),
            'can_give_my_group'=>0,
            'rz1'=>array('max_mins'=>120,'access'=>array()),
            'rz2'=>array('groups'=>array(),'between_notify'=>5,'between_notify_for_one'=>15,
                'chain'=>array(
                    'lvl1'=>array('access'=>'','time'=>''),
                    'lvl2'=>array('access'=>'','time'=>''),
                    'lvl3'=>array('access'=>'comments/add','time'=>120),
                    'lvl4'=>array('access'=>'','time'=>''),
                    'lvl5'=>array('access'=>'comments/add','time'=>120)
                    )
                )
           );

        return $cfg;
    }

/* ========================================================================== */
/* ========================================================================== */
    
    public function getSanctionsForUser($user_id){
        $result = $this->inDB->query('SELECT id,access FROM cms_sanction WHERE user_id = '.$user_id);
        if (!$this->inDB->num_rows($result)) { return false; }
        while($sanction = $this->inDB->fetch_assoc($result)){
            $sanctions[] = $sanction['access'];
        }
        $sanctions = implode(',', $sanctions);
        $sanctions = explode(',', $sanctions);
        $sanctions = array_unique($sanctions);
        return $sanctions;
    }
  
    public function getSanctions(){
        
        $sql = "SELECT s.*, u.login, u.nickname, g.login as g_login, g.nickname as g_nickname
        FROM cms_sanction s
        LEFT JOIN cms_users u ON s.user_id = u.id
        LEFT JOIN cms_users g ON s.who_gave_id = g.id
        WHERE 1=1 {$this->inDB->where}";
        if ($this->inDB->limit)$sql .= " LIMIT {$this->inDB->limit}";
        $result = $this->inDB->query($sql);
        $this->inDB->resetConditions();
        
        if (!$this->inDB->num_rows($result)) { return false; }
        $sanctions = array();
        while($sanction = $this->inDB->fetch_assoc($result)){
            $sanctions[$sanction['id']]['date']     = $sanction['date'];
            $sanctions[$sanction['id']]['datef']    = cmsCore::dateFormat($sanction['date'], true, true);
            $sanctions[$sanction['id']]['free_date']= $sanction['free_date'];
            $sanctions[$sanction['id']]['time_left']= $this->human_time_diff(time(), strtotime($sanction['free_date']));
            $sanctions[$sanction['id']]['user']     = array('id'=>$sanction['user_id'],'login'=>$sanction['login'],'nickname'=>$sanction['nickname'],'link'=>cmsUser::getProfileLink($sanction['login'],$sanction['nickname']));
            $sanctions[$sanction['id']]['access']   = $sanction['access'];
            $sanctions[$sanction['id']]['who_gave'] = $sanction['who_gave_id'] ?
                array('id'=>$sanction['who_gave_id'],'login'=>$sanction['g_login'],'nickname'=>$sanction['g_nickname'],'link'=>cmsUser::getProfileLink($sanction['g_login'],$sanction['g_nickname'])) :
                array('id'=>0,'login'=>'','nickname'=>'автомат','link'=>'автомат');
            $sanctions[$sanction['id']]['reason']   = $sanction['reason'];
        }
        return $sanctions;
    }
    
    public function getCountSanctions(){
        $sql = "SELECT 1
        FROM cms_sanction s
        WHERE 1=1 {$this->inDB->where}";
        $result = $this->inDB->query($sql);
        
        return $this->inDB->num_rows($result);
    }
    
    public function addSanction($user_id, $sanction, $who_gave_id){
        if(is_array($sanction['access']))$sanction['access'] = implode(',', $sanction['access']);
        
        $sql = "INSERT INTO cms_sanction (`id`, `date`, `free_date`, `user_id`, `access`, `who_gave_id`, `reason`)
                VALUES (NULL, NOW(), DATE_ADD(NOW(), INTERVAL '{$sanction['minutes']}' MINUTE), '$user_id', '{$sanction['access']}', '$who_gave_id', '{$sanction['reason']}')";
        $result = $this->inDB->query($sql);
        return $result;
    }
    
    public function updateSanction($user_id, $sanction){
        if(!$user_id)return false;
        if(is_array($sanction['access']))$sanction['access'] = implode(',', $sanction['access']);
        
        $sql = "UPDATE cms_sanction SET
            `free_date` = DATE_ADD(`date`, INTERVAL '{$sanction['minutes']}' MINUTE),
            `access` = '{$sanction['access']}',
            `reason` = '{$sanction['reason']}' WHERE id = $user_id";
        $result = $this->inDB->query($sql);
        return $result;
    }
    
    public function delSanction($id){
        if(!$id)return false;
        
        $sql = "DELETE FROM cms_sanction WHERE id = $id";
        $result = $this->inDB->query($sql);
        return $result;
    }
    
/* ========================================================================== */
/* ========================================================================== */
    
    public function getNotices(){
        
        $sql = "SELECT sn.*, u.login, u.nickname, g.login as g_login, g.nickname as g_nickname
        FROM cms_sanction_notice sn
        LEFT JOIN cms_users u ON sn.user_id = u.id
        LEFT JOIN cms_users g ON sn.who_gave_id = g.id
        WHERE 1=1 {$this->inDB->where}";
        if ($this->inDB->limit)$sql .= " LIMIT {$this->inDB->limit}";
        $result = $this->inDB->query($sql);
        $this->inDB->resetConditions();
        
        if (!$this->inDB->num_rows($result)) { return false; }
        $notices = array();
        while($notice = $this->inDB->fetch_assoc($result)){
            $notices[$notice['id']]['date']     = $notice['date'];
            $notices[$notice['id']]['datef']    = cmsCore::dateFormat($notice['date'], true, true);
            $notices[$notice['id']]['user']     = array('id'=>$notice['user_id'],'login'=>$notice['login'],'nickname'=>$notice['nickname'],'link'=>cmsUser::getProfileLink($notice['login'],$notice['nickname']));
            $notices[$notice['id']]['who_gave'] = array('id'=>$notice['who_gave_id'],'login'=>$notice['g_login'],'nickname'=>$notice['g_nickname'],'link'=>cmsUser::getProfileLink($notice['g_login'],$notice['g_nickname']));
            $notices[$notice['id']]['reason']   = $notice['reason'];
        }
        return $notices;
    }
    
    public function getCountNotices(){
        $sql = "SELECT 1
        FROM cms_sanction_notice sn
        WHERE 1=1 {$this->inDB->where}";
        $result = $this->inDB->query($sql);
        
        return $this->inDB->num_rows($result);
    }
    
    public function addNotice($user_id, $notice, $who_gave_id){
        
        $lvl = $this->inDB->rows_count('cms_sanction_notice', 'user_id = '.$user_id);
        $lvl++;
        
        $access = '';
        $time = 0;
        for ($i=1; $lvl>=$i; $i++) {
            $access = $this->config['rz2']['chain']['lvl'.$i]['access'] ? $access.($access ? ',' : '').$this->config['rz2']['chain']['lvl'.$i]['access'] : $access;
            $time = $this->config['rz2']['chain']['lvl'.$i]['time'] ? $this->config['rz2']['chain']['lvl'.$i]['time'] : $time;
        }
        if($access){
            $access = explode(',', $access);
            foreach($access as $key=>$value)$access[$key] = trim($value);
            $sanction['access'] = array_unique($access);
            $sanction['reason'] = 'Получение '.$lvl.'-го уровня предупреждений';
            $sanction['minutes']= $time;
            
            $this->addSanction($user_id, $sanction, '0');
        }
        
        $sql = "INSERT INTO cms_sanction_notice (`id`, `date`, `user_id`, `who_gave_id`, `reason`)
                VALUES (NULL, NOW(), '$user_id', '$who_gave_id', '{$notice['reason']}')";
        $result = $this->inDB->query($sql);
        return $result;
    }
    
    public function updateNotice($user_id, $notice){
        if(!$user_id)return false;
        
        $sql = "UPDATE cms_sanction_notice SET
            `reason` = '{$notice['reason']}' WHERE id = $user_id";
        $result = $this->inDB->query($sql);
        return $result;
    }
    
    public function delNotice($id){
        if(!$id)return false;
        
        $sql = "DELETE FROM cms_sanction_notice WHERE id = $id";
        $result = $this->inDB->query($sql);
        return $result;
    }
    
/* ========================================================================== */
/* ========================================================================== */
    
/**
  human_time_diff
  2012-01-18 by sergey.shuchkin[gav]gmail.com
*/
private function human_time_diff($from, $to, $format_pass = '%s назад', $format_now = 'сейчас', $format_future = 'через %s' ) {
    // Common time periods as an array of arrays
    $periods = array(
        array(60 * 60 * 24 * 365 , 'год','года','лет'),
        array(60 * 60 * 24 * 30 , 'месяц','месяца','месяцев'),
        array(60 * 60 * 24 * 7, 'неделя','недели','недель'),
        array(60 * 60 * 24 , 'день','дня','дней'),
        array(60 * 60 , 'час','часа','часов'),
        array(60 , 'минуту','минуты','минут')
    );
    $future = $to > $from;
    $diff = abs($from - $to); // Find the difference of time between now and the future
    // Loop around the periods, starting with the biggest
    for ($i =  0, $j = count($periods); $i < $j; $i++) {
        $seconds = $periods[$i][ 0];
        $name = $periods[$i][1];
        // Find the biggest whole period
        if (($n = floor($diff / $seconds)) >  0) break;
    }
    if ( $n ==  0 ) return $format_now;
    $plural = ($n%10==1 && $n%100!=11 ?  0 : ($n%10>=2 && $n%10<=4 && ($n%100<10 || $n%100>=20) ? 1 : 2));
    $result = $n.' '.$periods[$i][ $plural + 1 ];
    if ($i + 1 < $j) {
        // Retrieving the second relevant period
        $seconds2 = $periods[$i + 1][ 0];
        $name2 = $periods[$i + 1][1];
        // Only show it if it's greater than 0
        if (($n2 = floor(($diff - ($seconds * $n)) / $seconds2)) >  0) {
            $plural = ($n2%10==1 && $n2%100!=11 ?  0 : ($n2%10>=2 && $n2%10<=4 && ($n2%100<10 || $n2%100>=20) ? 1 : 2));
            $result .= ', ' . $n2 .' '.$periods[$i+1][ $plural + 1 ];
        }
    }
    return str_replace('%s', $result, ($future) ? $format_future : $format_pass );
}
/* ========================================================================== */
/* ========================================================================== */

}